//-----------------------------------------------------------------------
#property copyright "www.forex-tsd.com, modified by airquest@hotmail.com"
#property link      "www.forex-tsd.com, modified by airquest@hotmail.com"
//-----------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    LimeGreen
#property indicator_color2    Orange
#property indicator_width1    2
#property indicator_width2    2
#property indicator_minimum   0
#property indicator_maximum   1

//
//
//
//
//

extern int            StochasticPeriod       = 50;
extern ENUM_MA_METHOD MaMetod   = 2;
extern int            MaPeriod  = 6;
extern ENUM_MA_METHOD MaMetod2  = 3;
extern int            MaPeriod2 = 2;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double ExtMapBuffer1[];
double slope[];
double histoup[];
double histodn[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,histoup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histodn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer1);
   SetIndexBuffer(4,buffer2);
   SetIndexBuffer(5,buffer3);
   SetIndexBuffer(6,ExtMapBuffer1);
   SetIndexBuffer(7,slope);
   IndicatorShortName("Stochastic of HAMA ("+MaPeriod+","+MaMetod+","+MaPeriod2+","+MaMetod2+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double maOpen, maClose, maLow, maHigh, haClose;
   
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   int pos=Bars-counted_bars-1;
   while(pos>=0)
     {
      maOpen  =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN,pos);
      maClose =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
      maLow   =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW,pos);
      maHigh  =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH,pos);

      haClose=(maOpen+maHigh+maLow+maClose)/4;
      ExtMapBuffer1[pos]=haClose;

 	   pos--;
     }
   //
   //

   for(int i=limit; i>=0; i--)
   {
      buffer3[i] = iMAOnArray(ExtMapBuffer1,Bars,MaPeriod2,0,MaMetod2,i);
      
      //
      //
      //
      //
      //
      
      double hi = buffer3[ArrayMaximum(buffer3,StochasticPeriod,i)];
      double lo = buffer3[ArrayMinimum(buffer3,StochasticPeriod,i)];
      if (hi != lo)
            buffer1[i] = 100*(buffer3[i]-lo)/(hi-lo);
      else  buffer1[i] = 0.00;
      histodn[i] = EMPTY_VALUE;
      histoup[i] = EMPTY_VALUE;
      slope[i]   = slope[i+1];
         if (buffer1[i]>buffer1[i+1]) slope[i] =  1;
         if (buffer1[i]<buffer1[i+1]) slope[i] = -1;
         if (slope[i]== 1) histoup[i] = 1;
         if (slope[i]==-1) histodn[i] = 1;
   }         
   return(0);
}

//
//
//
//------------------------------------------------------------------